#include "cntl2.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int main(int argc, char**argv){
	struct in_addr 			ip;
	ControlPacketStatReply	st;
	unsigned int			BuffID;
	
	if (argc == 1){
		printf("Hogwash Buffer Status Query v1.0 by Anonpoet\n\n");
		printf("Sends an encrypted request for a buffer status\nand displays the results\n\n");
		printf("Usage:\n");
		printf("hstat <IP Adress> [<buffer id>|ALERT|RULES|LOG]\n");
		return 0;
	}
	
	inet_aton(argv[1],&ip);
	
	printf("Getting stat from %s\n",inet_ntoa(ip));
	
	BuffID=STOCK_BUFFER_ALERT;
	if (argc>2){
		if (strcmp(argv[2],"ALERT")==0){
			BuffID=STOCK_BUFFER_ALERT;
		}else if (strcmp(argv[2],"RULES")==0){
			BuffID=STOCK_BUFFER_RULES;
		}else if (strcmp(argv[2],"LOG")==0){
			BuffID=STOCK_BUFFER_LOG;
		}
	}
	
	hm_init("control.conf");
	if (hb_get_stat(ip, BuffID, &st)){
		printf("Buffer %u Statistics:\n", BuffID);
		printf("------------------------------------------------\n");
		printf("Size is %u\n",st.Size);
		printf("\n");
		printf("Snort Packet Statistics:\n");
		printf("------------------------------------------------\n");
		printf("TCP  : %u\n",st.TCPCount);
		printf("UDP  : %u\n",st.UDPCount);
		printf("ICMP : %u\n",st.ICMPCount);
		printf("ARP  : %u\n",st.ARPCount);
		printf("IPv6 : %u\n",st.IPV6Count);
		printf("IPX  : %u\n",st.IPXCount);
		printf("Other: %u\n",st.OtherCount);
		printf("\n");
		printf("Alerts: %u\n",st.AlertCount);
		printf("Logs  : %u\n",st.LogCount);
		printf("Drops : Not Yet Implemented\n");
	}else{
		printf("Error getting stat!\n");
	}
	hm_close();
}
